namespace LCAx
{

    public partial class Lcax
    {
        public Dictionary<string, ReferenceSourceForAssembly> Assemblies { get; set; }
        public string ClassificationSystem { get; set; }
        public string Comment { get; set; }
        public string Description { get; set; }
        public string FormatVersion { get; set; }
        public string Id { get; set; }
        public ImpactCategoryKey[] ImpactCategories { get; set; }
        public string LciaMethod { get; set; }
        public LifeCycleStage[] LifeCycleStages { get; set; }
        public Location Location { get; set; }
        public Dictionary<string, string> MetaData { get; set; }
        public string Name { get; set; }
        public string Owner { get; set; }
        public ProjectInfo ProjectInfo { get; set; }
        public ProjectPhase ProjectPhase { get; set; }
        public long? ReferenceStudyPeriod { get; set; }
        public Dictionary<string, Dictionary<string, double?>> Results { get; set; }
        public SoftwareInfo SoftwareInfo { get; set; }
    }

    public partial class ReferenceSourceForAssembly
    {
        public Classification[] Classification { get; set; }
        public string Comment { get; set; }
        public string Description { get; set; }
        public string Id { get; set; }
        public Dictionary<string, string> MetaData { get; set; }
        public string Name { get; set; }
        public Dictionary<string, ReferenceSourceForProduct> Products { get; set; }
        public double? Quantity { get; set; }
        public Dictionary<string, Dictionary<string, double?>> Results { get; set; }
        public ReferenceSourceForImpactDataSourceType Type { get; set; }
        public Unit? Unit { get; set; }
        public string Format { get; set; }
        public Dictionary<string, string> Overrides { get; set; }
        public string Uri { get; set; }
        public string Version { get; set; }
    }

    public partial class Classification
    {
        public string Code { get; set; }
        public string Name { get; set; }
        public string System { get; set; }
    }

    public partial class ReferenceSourceForProduct
    {
        public string Description { get; set; }
        public string Id { get; set; }
        public ReferenceSourceForImpactDataSource ImpactData { get; set; }
        public Dictionary<string, string> MetaData { get; set; }
        public string Name { get; set; }
        public double? Quantity { get; set; }
        public long? ReferenceServiceLife { get; set; }
        public Dictionary<string, Dictionary<string, double?>> Results { get; set; }
        public Transport[] Transport { get; set; }
        public ReferenceSourceForImpactDataSourceType Type { get; set; }
        public Unit? Unit { get; set; }
        public string Format { get; set; }
        public Dictionary<string, string> Overrides { get; set; }
        public string Uri { get; set; }
        public string Version { get; set; }
    }

    public partial class ReferenceSourceForImpactDataSource
    {
        public ReferenceSourceForImpactDataSourceType Type { get; set; }
        public string Comment { get; set; }
        public Conversion[] Conversions { get; set; }
        public Unit? DeclaredUnit { get; set; }
        public string FormatVersion { get; set; }
        public string Id { get; set; }
        public Dictionary<string, Dictionary<string, double?>> Impacts { get; set; }
        public Country? Location { get; set; }
        public Dictionary<string, string> MetaData { get; set; }
        public string Name { get; set; }
        public DateTimeOffset? PublishedDate { get; set; }
        public long? ReferenceServiceLife { get; set; }
        public Source Source { get; set; }
        public Standard? Standard { get; set; }
        public SubType? Subtype { get; set; }
        public DateTimeOffset? ValidUntil { get; set; }
        public string Version { get; set; }
        public string Format { get; set; }
        public Dictionary<string, string> Overrides { get; set; }
        public string Uri { get; set; }
    }

    public partial class Conversion
    {
        public string MetaData { get; set; }
        public Unit To { get; set; }
        public double Value { get; set; }
    }

    public partial class Source
    {
        public string Name { get; set; }
        public string Url { get; set; }
    }

    public partial class Transport
    {
        public double Distance { get; set; }
        public Unit DistanceUnit { get; set; }
        public string Id { get; set; }
        public ImpactDataSource ImpactData { get; set; }
        public LifeCycleStage[] LifeCycleStages { get; set; }
        public string Name { get; set; }
    }

    public partial class ImpactDataSource
    {
        public string Comment { get; set; }
        public Conversion[] Conversions { get; set; }
        public Unit DeclaredUnit { get; set; }
        public string FormatVersion { get; set; }
        public string Id { get; set; }
        public Dictionary<string, Dictionary<string, double?>> Impacts { get; set; }
        public Country Location { get; set; }
        public Dictionary<string, string> MetaData { get; set; }
        public string Name { get; set; }
        public DateTimeOffset? PublishedDate { get; set; }
        public long? ReferenceServiceLife { get; set; }
        public Source Source { get; set; }
        public Standard? Standard { get; set; }
        public SubType? Subtype { get; set; }
        public DateTimeOffset? ValidUntil { get; set; }
        public string Version { get; set; }
    }

    public partial class Location
    {
        public string Address { get; set; }
        public string City { get; set; }
        public Country Country { get; set; }
    }

    public partial class ProjectInfo
    {
        public long? BuildingCompletionYear { get; set; }
        public ValueUnit BuildingFootprint { get; set; }
        public ValueUnit BuildingHeight { get; set; }
        public ValueUnit BuildingMass { get; set; }
        public string[] BuildingModelScope { get; set; }
        public long? BuildingPermitYear { get; set; }
        public BuildingType? BuildingType { get; set; }
        public BuildingTypology[] BuildingTypology { get; set; }
        public long? BuildingUsers { get; set; }
        public string[] Certifications { get; set; }
        public double? EnergyDemandElectricity { get; set; }
        public double? EnergyDemandHeating { get; set; }
        public double? EnergySupplyElectricity { get; set; }
        public double? EnergySupplyHeating { get; set; }
        public double? ExportedElectricity { get; set; }
        public long? FloorsAboveGround { get; set; }
        public long? FloorsBelowGround { get; set; }
        public string FrameType { get; set; }
        public GeneralEnergyClass? GeneralEnergyClass { get; set; }
        public AreaType GrossFloorArea { get; set; }
        public AreaType HeatedFloorArea { get; set; }
        public string LocalEnergyClass { get; set; }
        public RoofType? RoofType { get; set; }
        public ProjectInfoType Type { get; set; }
    }

    public partial class ValueUnit
    {
        public Unit Unit { get; set; }
        public double Value { get; set; }
    }

    public partial class AreaType
    {
        public string Definition { get; set; }
        public Unit Unit { get; set; }
        public double Value { get; set; }
    }

    public partial class SoftwareInfo
    {
        public string CalculationType { get; set; }
        public string GoalAndScopeDefinition { get; set; }
        public string LcaSoftware { get; set; }
    }

    public enum Unit { Kg, Kgm3, Km, Kwh, L, M, M2, M2R1, M3, Pcs, Tones, TonesKm, Unknown };

    public enum Country { Abw, Afg, Ago, Aia, Ala, Alb, And, Are, Arg, Arm, Asm, Ata, Atf, Atg, Aus, Aut, Aze, Bdi, Bel, Ben, Bes, Bfa, Bgd, Bgr, Bhr, Bhs, Bih, Blm, Blr, Blz, Bmu, Bol, Bra, Brb, Brn, Btn, Bvt, Bwa, Caf, Can, Cck, Che, Chl, Chn, Civ, Cmr, Cod, Cog, Cok, Col, Com, Cpv, Cri, Cub, Cuw, Cxr, Cym, Cyp, Cze, Deu, Dji, Dma, Dnk, Dom, Dza, Ecu, Egy, Eri, Esh, Esp, Est, Eth, Fin, Fji, Flk, Fra, Fro, Fsm, Gab, Gbr, Geo, Ggy, Gha, Gib, Gin, Glp, Gmb, Gnb, Gnq, Grc, Grd, Grl, Gtm, Guf, Gum, Guy, Hkg, Hmd, Hnd, Hrv, Hti, Hun, Idn, Imn, Ind, Iot, Irl, Irn, Irq, Isl, Isr, Ita, Jam, Jey, Jor, Jpn, Kaz, Ken, Kgz, Khm, Kir, Kna, Kor, Kwt, Lao, Lbn, Lbr, Lby, Lca, Lie, Lka, Lso, Ltu, Lux, Lva, Mac, Maf, Mar, Mco, Mda, Mdg, Mdv, Mex, Mhl, Mkd, Mli, Mlt, Mmr, Mne, Mng, Mnp, Moz, Mrt, Msr, Mtq, Mus, Mwi, Mys, Myt, Nam, Ncl, Ner, Nfk, Nga, Nic, Niu, Nld, Nor, Npl, Nru, Nzl, Omn, Pak, Pan, Pcn, Per, Phl, Plw, Png, Pol, Pri, Prk, Prt, Pry, Pse, Pyf, Qat, Reu, Rou, Rus, Rwa, Sau, Sdn, Sen, Sgp, Sgs, Shn, Sjm, Slb, Sle, Slv, Smr, Som, Spm, Srb, Ssd, Stp, Sur, Svk, Svn, Swe, Swz, Sxm, Syc, Syr, Tca, Tcd, Tgo, Tha, Tjk, Tkl, Tkm, Tls, Ton, Tto, Tun, Tur, Tuv, Twn, Tza, Uga, Ukr, Umi, Unknown, Ury, Usa, Uzb, Vat, Vct, Ven, Vgb, Vir, Vnm, Vut, Wlf, Wsm, Yem, Zaf, Zmb, Zwe };

    public enum Standard { En15804A1, En15804A2, Unknown };

    public enum SubType { Generic, Industry, Representative, Specific };

    public enum ReferenceSourceForImpactDataSourceType { Actual, Reference };

    public enum LifeCycleStage { A0, A1A3, A4, A5, B1, B2, B3, B4, B5, B6, B7, B8, C1, C2, C3, C4, D };

    public enum ImpactCategoryKey { Adpe, Adpf, Ap, Cru, Eee, Eet, Ep, EpFw, EpMar, EpTer, EtpFw, Fw, Gwp, GwpBio, GwpFos, GwpLul, HtpC, HtpNc, Hwd, Irp, Mer, Mrf, Nhwd, Nrsf, Odp, Penre, Penrm, Penrt, Pere, Perm, Pert, Pm, Pocp, Rsf, Rwd, Sm, Sqp, Wdp };

    public enum BuildingModelScope { BuildingServices, ExternalWorks, FacilitatingWorks, FfE, Finishes, Substructure, SuperstructureEnvelope, SuperstructureFrame, SuperstructureInternalElements };

    public enum BuildingType { DeconstructionAndNewConstructionWorks, Demolition, ExtensionWorks, FitOutWorks, NewConstructionWorks, Operations, Other, RetrofitAndExtensionWorks, RetrofitWorks };

    public enum BuildingTypology { Agricultural, Commercial, Industrial, Infrastructure, Office, Other, Public, Residential };

    public enum GeneralEnergyClass { Advanced, Existing, Standard, Unknown };

    public enum RoofType { Flat, Other, Pitched, Pyramid, Saddle };

    public enum ProjectInfoType { BuildingInfo, InfrastructureInfo };

    public enum ProjectPhase { ConceptDesign, Construction, InUse, Other, PostCompletion, StrategicDesign, TechnicalDesign };
}
